#ifndef RESPONSE_H
#define RESPONSE_H

typedef struct {
	char *data;
	int   size;
} RAW_RESPONSE;

typedef struct {
	int head_line;
	int body_line;
	char **head;
	char **body;
} LV1_RESPONSE;

#ifdef __cplusplus
extern "C" {
#endif

extern int  setup_response_lv1(RAW_RESPONSE *raw, LV1_RESPONSE *lv1);
extern void teardown_response_lv1(LV1_RESPONSE *lv1);
extern int  http_status_code(LV1_RESPONSE *lv1);

#ifdef __cplusplus
}
#endif

#endif /* RESPONSE_H */
