#ifndef TYPE_H
#define TYPE_H

#ifdef _WIN32
#define  int8_t  char
#define uint8_t  unsigned char
#define  int16_t short
#define uint16_t unsigned short
#define  int32_t int
#define uint32_t unsigned int
#define  int64_t __int64
#define uint64_t unsigned __int64
#else
#include <inttypes.h>
#endif /* _WIN32 */

typedef struct {
	uint32_t pa;     /*  0  MSB 32 bit   */
	uint32_t pb;     /*  4  LSB 32 bit   */
	uint32_t ka;     /*  8  MSB 32 bit     */
	uint32_t kb;     /* 12  LSB 32 bit     */
	uint32_t ca[8];  /* 16 Í MSB 32 bit */
	uint32_t cb[8];  /* 48 Í LSB 32 bit */
} WORK_INFO;

typedef struct {
	uint32_t ka;     /*  MSB 24 bit                 */
	uint32_t kb;     /* ƒ̌ LSB 32 bit         */
	uint64_t c[8];   /* ΏۈÍ                    */
	uint64_t k[8];   /*                     */
	uint8_t  ff;     /* c&k ̔tO              */
	uint8_t  st;     /* 0=, 1=, 2=  */
	uint8_t  pad[6]; /* g[^ 32 byte ɂlߕ */
} WORK_UNIT;

typedef struct {
	char      rank[64];  /* ʕ                        */
	uint64_t  plaintext; /* Ώە                          */
	char      id[32+4];  /* NCAg ID                   */
	uint32_t  time;      /* 蓖Ď                      */
	uint32_t  padding;   /* unit  8 byte align ɂlߕ */
	uint32_t  count;     /* uint                            */
	WORK_UNIT unit[8];   /* 蓖ăjbg                  */
	char      proxy_host[1024];
	int       proxy_port;
} WORK_BLOCK;

#endif /* TYPE_H */
